package tw.net.ocs.example;

/**
	A simple agent that does a little work
	and keeps a listener informed about its activities. 
*/
public class Agent {

		/** A listener which gets informed about the agent's activities */
	private Listener listener_;

	/**
		The agent is constructed and handed a listener.

		@param li the listener 
	*/
	public Agent(Listener li) {
		System.out.println("\nConstruction, setting the listener");
		listener_=li;
	}

	/**
		Starts the agent and makes it do its (modest) work
	*/
	public void act() {
			// say initial hello
		System.out.println("About to call listener (starting).");
		listener_.receive("Listen, agent starts to work...");

		for (int a=1; a<=5; ++a) {
				// (pretend to) work for a second
			try { Thread.sleep(1000); }
			catch (InterruptedException x) {}
				// and talk about it
			System.out.println("About to call listener (done with #"+a+").");
			listener_.receive("Listen, agent done with action #"+a+".");
		}
			// say final hello
		System.out.println("About to call the listener (finished).");
		listener_.receive("Listen, agent finished work, bye-bye!");
	}

}

