package tw.net.ocs.example;

/**
	<pre>
	Example 1 sets the scene with a purely local application,
	putting the participating classes Agent and Listener/ListenerImpl
	to a first use.

	The following examples will depart from here, turning it into a
	variety of client/server structures.

	----------------------------------
	Scenario:
	HERE           |          THERE
	Agent+Listener |
	----------------------------------

	To run the demo, enter
			java -cp ocs-examples.jar tw.net.ocs.example.Example1
	</pre>

	@author Tillmann Wegst
*/
public class Example1 {
	public static void main(String[] args) {

		System.out.println("Running Example1: Agent+Listener HERE");

			// Create an Agent, pass it a Listener
		Agent agent = new Agent(new ListenerImpl());
			// ... and let the Agent act
		agent.act();
	}
}

