package tw.net.ocs.proxy;

import tw.net.ocs.*;

/**
	<pre>
	OCSelot class proxy derivation of tw.net.ocs.example.Agent.

	Instances of this ("proxies") are associated with server-side instances ("subjects")
	of tw.net.ocs.example.Agent.

	................................................................
	DO NOT MODIFY - SEE DOCUMENTATION FOR VARIANTS OF CODE CREATION!
	CODE GENERATED AUTOMATICALLY BY tw.net.ocs.OCSClassProxyFactory: 21.02.2006 21:47
	OCSelot 1.3 by Tillmann Wegst // Software Development
	</pre>

	@author Tillmann Wegst
*/
public class TwNetOcsExampleAgent extends tw.net.ocs.example.Agent implements OCSClassProxy, java.io.Serializable {

	private String subjectID_;
	private tw.net.ocs.OCSClient ocsClient_;
	private static tw.net.ocs.OCSClient staticOCSClient_;

	/**
		<pre>
		Constructs a "proxy" extension of tw.net.ocs.example.Agent, associated with a
		server-side "subject" instance of its base class.

		Parameters "a..z" correspond to those of the corresponding base class constructor tw.net.ocs.example.Agent(tw.net.ocs.example.Listener a).
		</pre>

		@param ocsClient object responsible for client side communication
		@param create create new server-side subject (or attach to existing instance)?
		@param subjectID ID of server-side subject
		@throws java.lang.OCSRuntimeException if creation, attachment or basic operation fails
	*/
	public TwNetOcsExampleAgent(tw.net.ocs.example.Listener a, tw.net.ocs.OCSClient ocsClient, boolean create, String subjectID) {
		super(a);
		if (ocsClient==null) ocsClient=OCSClient.getStandardInstance();
		Object erg=ocsClient.send(create?1:2,tw.net.ocs.example.Agent.class,subjectID,null,new Class[]{tw.net.ocs.example.Listener.class},new Object[]{a});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
		subjectID_=(java.lang.String)erg;
		ocsClient_=ocsClient;
		ocsClient_.disconnect();
	}

	/**
		<pre>
		Constructs a "proxy" extension of tw.net.ocs.example.Agent, associated with a
		server-side "subject" instance of its base class.

		Uses the OCSClient installed in this class, otherwise the default OCSClient.
		On the server side a new instance of class tw.net.ocs.example.Agent will be allocated.
		The subject ID will be created automatically (or reused).

		Parameters "a..z" correspond to those of the corresponding base class constructor tw.net.ocs.example.Agent(tw.net.ocs.example.Listener a).
		</pre>

		@throws java.lang.OCSRuntimeException if creation, attachment or basic operation fails
	*/
	public TwNetOcsExampleAgent(tw.net.ocs.example.Listener a) {
		this(a,(tw.net.ocs.OCSClient)null,true,(String)null);
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public void act() {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"act",new Class[]{},new Object[]{});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public int hashCode() {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"hashCode",new Class[]{},new Object[]{});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
		return ((java.lang.Integer)erg).intValue();
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public final java.lang.Class final_getClass() {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"getClass",new Class[]{},new Object[]{});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
		return (java.lang.Class)erg;
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public final void final_wait(long a, int b) throws java.lang.InterruptedException {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"wait",new Class[]{long.class,int.class},new Object[]{new java.lang.Long(a),new java.lang.Integer(b)});
		if (erg instanceof java.lang.InterruptedException) throw (java.lang.InterruptedException)erg;
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public final void final_wait() throws java.lang.InterruptedException {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"wait",new Class[]{},new Object[]{});
		if (erg instanceof java.lang.InterruptedException) throw (java.lang.InterruptedException)erg;
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public final void final_wait(long a) throws java.lang.InterruptedException {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"wait",new Class[]{long.class},new Object[]{new java.lang.Long(a)});
		if (erg instanceof java.lang.InterruptedException) throw (java.lang.InterruptedException)erg;
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
	}

	/**
		@param a {@inheritDoc}
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public boolean equals(java.lang.Object a) {
		if (a instanceof TwNetOcsExampleAgent)
			return ((TwNetOcsExampleAgent)a).ocsGetSubjectID().equals(subjectID_) && ((TwNetOcsExampleAgent)a).ocsGetSubjectAddress().equals(ocsGetSubjectAddress());
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"equals",new Class[]{java.lang.Object.class},new Object[]{a});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
		return ((java.lang.Boolean)erg).booleanValue();
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public final void final_notify() {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"notify",new Class[]{},new Object[]{});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public final void final_notifyAll() {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"notifyAll",new Class[]{},new Object[]{});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
	}

	/**
		@throws java.lang.OCSRuntimeException in case of a communication error
	*/
	public java.lang.String toString() {
		Object erg=ocsClient_.send(3,tw.net.ocs.example.Agent.class,subjectID_,"toString",new Class[]{},new Object[]{});
		if (erg instanceof OCSRuntimeException) throw (OCSRuntimeException)erg;
		return (java.lang.String)erg;
	}

	/**
		<pre>
		Returns the ID of a server-side tw.net.ocs.example.Agent instance
		</pre>

		@return the subject ID
	*/
	public String ocsGetSubjectID() {
		return subjectID_;
	}

	/**
		<pre>
		Returns the server address hosting the tw.net.ocs.example.Agent instance
		</pre>

		@return the address of the server hosting the subject
	*/
	public String ocsGetSubjectAddress() {
		return ocsClient_.getServerAddress();
	}

	/**
		<pre>
		Returns the OCSClient used by the proxy to forward
		requests to the subject.
		</pre>

		@return the associated OCSClient instance
		@since 1.3
	*/
	public OCSClient ocsGetClient() {
		return ocsClient_;
	}

	/**
		<pre>
		Sets the OCSClient to be used in class methods.

		If none is specified, all static methods use the
		current standard OCSClient instance
		</pre>

		@param sc the OCSClient
	*/
	public static void ocsSetClientForClassMethods(OCSClient sc) {
		staticOCSClient_=sc;
	}

	/**
		<pre>
		Detaches the proxy from its subject.

		Allows the remote subject to be removed from the server
		and then get garbage collected.
		</pre>
		@since 1.3
	*/
	public void ocsDetachFromSubject() {
		ocsClient_.detachProxy(tw.net.ocs.example.Agent.class,subjectID_);
		subjectID_=null;
	}

	/**
		<pre>
		Finalizes the proxy by detaching it from its subject.

		Allows the remote subject to be removed from the server
		and then get garbage collected.
		</pre>
		@since 1.3
	*/
	protected void finalize() throws Throwable {
		super.finalize();
		ocsClient_.detachProxy(tw.net.ocs.example.Agent.class,subjectID_);
	}
}
